;###########################################################################
;
; LICENSE
;
; Copyright 2004 CAPCA at University of Calgary.
;
; This software is provided "as-is", without any express or
; implied warranty. In no event will the authors be held liable
; for any damages arising from the use of this software.
;
; Permission is granted to anyone to use this software for any
; purpose, including commercial applications, and to alter it and
; redistribute it freely, subject to the following restrictions:
;
; 1. The origin of this software must not be misrepresented; you must
;    not claim you wrote the original software. If you use this software
;    in a product, an acknowledgment in the product documentation
;    would be appreciated, but is not required.
;
; 2. Altered source versions must be plainly marked as such, and must
;    not be misrepresented as being the original software.
;
; 3. This notice may not be removed or altered from any source distribution.
;
;
; The newest version is available from http://www.capca.ucalgary.ca/software
;
;###########################################################################
;
; IsoSurface object
;
; Created Winter 2001/2002
;   By M. S. Joergensen
;
; Modification history:
;
; To be used by JETGET tools
;

FUNCTION grIsoSurface::GetX1Min

  RETURN, Self.x1min
END

FUNCTION grIsoSurface::GetX2Min

  RETURN, Self.x2min
END

FUNCTION grIsoSurface::GetX3Min

  RETURN, Self.x3min
END

FUNCTION grIsoSurface::GetX1Max

  RETURN, Self.x1max
END

FUNCTION grIsoSurface::GetX2Max

  RETURN, Self.x2max
END

FUNCTION grIsoSurface::GetX3Max

  RETURN, Self.x3max
END

FUNCTION grIsoSurface::INIT, Data, Level, c, d, Style, ColorTabel = ColorTabel, AxisColor = AxisColor

    Default, Level, 0.001
    Default, Style, 1
    Default, ColorTabel, 20
    Default, AxisColor, [255, 0, 0]

    IF (self->IDLgrModel::Init(_EXTRA=e) NE 1) THEN RETURN, 0

    S = SIZE(Data)

    Pal = OBJ_NEW('IDLgrPalette')
    Pal->LoadCT, 20

;    SHADE_VOLUME, Data, Level, c, d

    if n_elements(c) eq 0 then begin 
       print, "WARNING: you specified a value outside the Data range. Max(Data) = ", max(data), ", min(Data) = ", min(data), "."
    endif else begin

    Image = OBJ_NEW('IDLgrImage', Palette = pal, Data = BYTSCL(c))

    Self.oSurf = OBJ_NEW('IDLgrPolygon', DATA=c, Polygons=d, shading=1, Style = Style+1, TEXTURE_MAP = Image, /TEXTURE_INTERP, COLOR = [0,0,255],Fill_Pattern=opattern, _EXTRA = e)
;    Self.oSurf = OBJ_NEW('IDLgrPolygon', DATA=c, Polygons=d, shading=1, Style = 2, TEXTURE_MAP = Image, /TEXTURE_INTERP, COLOR = [0,0,255], _EXTRA = e)
;    Self.oSurf = OBJ_NEW('IDLgrPolygon', DATA=c, Polygons=d, COLOR = [0,0,128], style=2, shading=1)
     

    Self.oAxis = OBJ_NEW('IDLgrPolyline', [0,S[1]], [S[2]/2,S[2]/2], [S[3]/2,S[3]/3], Color = AxisColor)

;    oXTitle = OBJ_NEW('IDLgrText', XTitle, LOCATION=[0,0])
;    oYTitle = OBJ_NEW('IDLgrText', YTitle, LOCATION=[0,0])

    Self->Add, Self.oSurf
    Self->Add, Self.oAxis

    Self->Translate, 1.0, -.5*s[2], -0.5*s[3]
    endelse
    return, 1
END

PRO grIsoSurface__define

  struct = { grIsoSurface, INHERITS IDLgrModel, oSurf: OBJ_NEW(), oAxis: OBJ_NEW(), $
             x1min: 0., x2min: 0., x3min:0., x1max:0., x2max:0., x3max:0. }

END
