;###########################################################################
;
; LICENSE
;
; Copyright 2004 CAPCA at University of Calgary.
;
; This software is provided "as-is", without any express or
; implied warranty. In no event will the authors be held liable
; for any damages arising from the use of this software.
;
; Permission is granted to anyone to use this software for any
; purpose, including commercial applications, and to alter it and
; redistribute it freely, subject to the following restrictions:
;
; 1. The origin of this software must not be misrepresented; you must
;    not claim you wrote the original software. If you use this software
;    in a product, an acknowledgment in the product documentation
;    would be appreciated, but is not required.
;
; 2. Altered source versions must be plainly marked as such, and must
;    not be misrepresented as being the original software.
;
; 3. This notice may not be removed or altered from any source distribution.
;
;
; The newest version is available from http://www.capca.ucalgary.ca/software
;
;###########################################################################
;
Pro maxminvar_1, var, bid, eid, ini, q, tbi=tbi, along=along, $
    endslice=endslice, sbi=sbi

common setupvariables

common maxmin_1, inj, fmin, fmax
common new_variables

;..........................................................................

IF N_ELEMENTS(bid)        EQ 0     THEN bid     = 1
IF N_ELEMENTS(eid)        EQ 0     THEN eid     = 25
IF N_ELEMENTS(ini)        EQ 0     THEN ini     = 30
IF N_ELEMENTS(count)      EQ 0     THEN count   = 2
IF N_ELEMENTS(tbi)        EQ 0     THEN tbi     = 1
IF N_ELEMENTS(dim)        EQ 0     THEN dim     = '3-D'
IF N_ELEMENTS(endslice)   EQ 0     THEN endslice = ini
IF N_ELEMENTS(sbi)        EQ 0     THEN sbi = 1

;
if endslice eq ini then begin
  countmin = fltarr((eid-bid)/tbi+1)
  countmax = fltarr((eid-bid)/tbi+1)
endif else begin
  countmin = fltarr((endslice-ini)/sbi+1)
  countmax = fltarr((endslice-ini)/sbi+1)
endelse
;
for nid = bid, eid, tbi do begin

countdata=getdata(var, nid)
if n_elements(countdata) eq 1 then if countdata eq 0 then stop
if (dim eq '3') then begin
for sid = ini, endslice, sbi do begin
case along of
0: begin
if endslice eq ini then begin
countmax[(nid-bid)/tbi] = max(countdata[ini,*,*])
countmin[(nid-bid)/tbi] = min(countdata[ini,*,*])
endif else begin
countmax[(sid-ini)/sbi] = max(countdata[sid,*,*])
countmin[(sid-ini)/sbi] = min(countdata[sid,*,*])
endelse
;
end

1: begin
if endslice eq ini then begin
countmax[(nid-bid)/tbi] = max(countdata[*,ini,*])
countmin[(nid-bid)/tbi] = min(countdata[*,ini,*])
endif else begin
countmax[(sid-ini)/sbi] = max(countdata[*,sid,*])
countmin[(sid-ini)/sbi] = min(countdata[*,sid,*])
endelse
;
end

2: begin
if endslice eq ini then begin
countmin[(nid-bid)/tbi] = min(countdata[*,*,ini])
countmax[(nid-bid)/tbi] = max(countdata[*,*,ini])
endif else begin
countmin[(sid-ini)/sbi] = min(countdata[*,*,sid])
countmax[(sid-ini)/sbi] = max(countdata[*,*,sid])
endelse
;
end

endcase
endfor
endif
if (dim eq '2') then begin
countmin[(nid-bid)/tbi] = min(countdata[*,*])
countmax[(nid-bid)/tbi] = max(countdata[*,*])
;
endif
countdata=0
endfor
;
fmin = min(countmin)
fmax = max(countmax)
;
end
